CHANGES - ESP Ghostscript 8.15.4 - 2007-03-14
---------------------------------------------

CHANGES IN 8.15.4

	- The configure script did not add the Brother drivers by
	  default (STR #2214)
	- The configure script did not add the CUPS fonts
	  directory to the default font path.
	- Changed the default substitution glyph back to .notdef
	  since space is not always present (STR #2163)
	- Interpreter crash bug fixed (STR #2199)
	- The dvipdf script now supports the dvips -R options
	  (STR #2027)
	- The packaging files did not restart the CUPS scheduler
	  after installing the pstoraster.convs file.
	- The FreeType support did not do the proper
	  substitutions.


CHANGES IN 8.15.3

	- The install_prefix variable was not used consistently
	  when installing from source (STR #1949)
	- PageSize policy 3 was unimplementable and has been
	  converted to policy 7, impose size (STR #1794)
	- Duplex, Tumble, and ManualFeed were not working
	  properly (STR #1987)
	- pdf2ps could generate a "null setpagesize" command (STR
	  #1641)
	- CJK font handling fix (STR #1639)
	- Fixed a crash bug with the X11 driver (STR #1635)
	- Added support for GTK+ 2.0 (STR #1633)
	- Added dynamically loaded driver support for *BSD (STR
	  #1628)
	- "make install" didn't work without --enable-dynamic on
	  some platforms (STR #1611)
	- Fixed a pdf2ps error with images (STR #1779)
	- Translated the Japanese comments in
	  addons/opvp/opvp_common.h (OpenPrinting Vector driver,
	  device "opvp") to english (STR  #1844, thanks to Todd
	  Fujinaka from Intel).
	- Updated KRGB support in the "ijs" device to version
	  1.3, fixing bugs and adding KRGB 1-bit and 8-bit
	  support (Thanks to David Suffield from HP).
	- CJKV support will be available as default.
	- Added gs8 CJKV patch
	- Fix compilation on systems that don't have gtk (but
	  still want the x11 driver)
	- The omni driver doesn't use glib -- update configure.ac
	  accordingly
	- Fix ps2epsi in locales where ~ comes before ! (STR #1643)
	- Use mktemp in ps2epsi if available (STR #1630)
	- New --enable/disable-fontconfig switch, allows the use
	  of fontconfig to retreive fonts lists on Unix (STR
	  #1631, based on patch from Craig Ritter)
	- Make fapi_ft compile with system freetype (STR #1632)


CHANGES IN 8.15.2

	- Ghostscript error messages now start with CUPS prefix
	  strings (ERROR: or CRIT:, as appropriate)
	- Updated the setpagedevice support to allow Duplex,
	  ManualFeed, and Tumble attributes to be set, even if
	  the underlying driver does not implement them (STR
	  #1598)
	- The eplaser driver incorrectly errored out if TRUE and
	  FALSE were already defined (STR #1336)
	- Fixed install-shared target to work on non-shared
	  installs (STR #1334)
	- Dynamically loaded driver support incorrectly required
	  X11 (STR #1351)
	- The pdfopt utility didn't guard against passing the
	  same filename twice, which would cause the PDF file to
	  become corrupted (STR #1399)
	- The cdj driver incorrectly closed the device when
	  changing BitsPerPixel values (STR #1577)
	- Updated the CMap files to the latest (STR #1345)
	- PostScript files that set the ManualFeed attribute
	  didn't work (STR #1570)
	- Now unconditionally include <time.h> to work around a
	  bug in the Compaq C compiler header files (STR #1539,
	  STR #1549)
	- gv did not work with the gsx of ESP GhostScript with
	  shared libgs (STR #1419, STR #1433)
	- Added support for CUPS 1.2 cupsBorderlessScalingFactor,
	  cupsImagingBBox, cupsPageSize, and cupsPageSizeName
	  page device attributes (STR #1406)
	- Updated Epson-Avasys driver for the Epson laser
	  printers to the newest version. Added devices "lps4500"
	  and "lps6500" to support the newest models (STR #1507,
	  thanks to Olaf Meeuwissen from Avasys).
	- The opvp driver fixed the bug that 1bpp bitmap was
	  printed in reverse color.
	- The opvp driver do not ignore blank page
	- The opvp drievr use snprintf instead of sprintf to 
	  avoid a few potential security holes.
	- The opvp driver use fabs function instead of fabsf
	  function (STR #1291).
	- Allow non-standard glyph names when synthesising an
	  Encoding  for 'glyphshow' to avoid the non-standard TTF
	  glyphs being expanded to outlines (STR #1455).
	- Updated KRGB support in the "ijs" device to version
	  1.2, fixing several buffer overflows and memory leaks,
	  especially avoiding segfaults when printing full-bleed
	  with the HPIJS driver on HP inkjets (Thanks to David
	  Suffield from HP).
	- Fixed rendering of images when converting PostScript to
	  PDF with "ps2pdf", fixed also a crash when generating
	  PDF files with the "pdfwrite" device (Thanks to Werner
	  Fink from SuSE).
	- Some files of the shared X11 driver were still not
	  built with CC_SHARED (gdevxcmp.c, gsparamx.c).
	- libijs had still some hard-coded /usr/lib, this broke
	  building on 64-bit systems.
	- Build the shared library of libijs as versioned library
	  by default.
	- Fixed a SEGV. It seems that the new vector device makes
	  the bbox device doing an allocation in
	  gx_general_fill_path(). Seems to have fixed STR #1116
	  (Thanks to Werner Fink from SuSE).
	- Applied fix for vertical japanese text from
	  http://www.gssm.otsuka.tsukuba.ac.jp/staff/ohki/gs850-patch-mine
	  (Thanks to Werner Fink from SuSE).
	- Adapted the color model in the "pcl3" driver to
	  GhostScript 8.15 (Thanks to Werner Fink from SuSE).
	- Fixed a memory overflow in the "lips4" driver (Thanks
	  to Werner Fink from SuSE).
	- "cgm*" drivers are now able to write onto a pipe
	  (Thanks to Werner Fink from SuSE).
	- Double free fixed (in gsdevice.c, Thanks to Werner Fink
	  from SuSE).
	- SEGV in "inferno" driver because the struct
	  "inferno_device" was not created but it was accessed to
	  its elements (Thanks to Werner Fink from SuSE).
	- Adapted the color model in the "devicen" driver to
	  GhostScript 8.15 (Thanks to Werner Fink from SuSE).
	- Wrongly entered paper dimensions in the "cljet5" driver
	  fixed (Thanks to Werner Fink from SuSE).


CHANGES IN 8.15.1

	- The shared X11 driver was not built with the correct
	  linker command (CCLD instead of CC_SHARED) (STR #1255)
	- The opvp driver incorrectly assumed that CODESET was
	  supported on all platforms that supported iconv (STR
	  #1247)
	- Updated the iconv checks so they work on more platforms
	  (STR #1154)
	- Added support in the "cups" driver for the
	  CUPS_CSPACE_RGBW colorspace (new in MacOS X 10.4 and
	  CUPS 1.2)
	- Added "SET RENDERMODE=..." PJL command to header of the
	  output of the "pxlmono" and "pxlcolor" drivers, this
	  way color laser printers get correctly switched between
	  grayscale and color mode and are this way often four
	  times faster in grayscale (Thanks to Jonathan Kamens,
	  jik at kamens dot brookline dot ma dot us, for this
	  fix).
	- Corrected Legal paper size definition for the "pxlmono"
	  and  "pxlcolor" drivers (Thanks to Jonathan Kamens, jik
	  at kamens  dot brookline dot ma dot us, for this fix).
	- Added some missing "$(install_prefix)"in the install
	  procedure of the extra files for "pcl3" driver.
	- The lips4 driver used a small string buffer to hold the
	  output resolution, which would cause a buffer overflow
	  for resolutions > 99 (STR #1241).


CHANGES IN 8.15rc4

	- Merged fixes from the GPL Ghostscript repository.
	- Fixed multiple media selection bugs (STR #1172, STR
	  #1204)
	- Fix a FreeType bug on 64-bit platforms (STR #1235)
	- Fixed problems when rendering certain PostScript files
	  on 64-bit platforms (STR #1168, thanks to Werner Fink
	  from SuSE)
	- Added long standing update from the author of "bjc600"
	  and "bjc800" (Thanks to Werner Fink from SuSE)
	- Switched back to old color model in the "bjc600" and
	  "bjc800" drivers. Now one can use "-dBitsPerPixel=1"
	  without getting an error message and a segfault (Thanks
	  to Werner Fink from SuSE)
	- Use dci macro in the "lx5000" driver (Thanks to Werner
	  Fink from SuSE)
	- Resource directory now determined based on CMap
	  directory, without this change the first directory from
	  LIBPATH is taken, and so, if set, GS_LIB selects the
	  directory and this usually leads to an error (Thanks to
	  Werner Fink from SuSE)
	- Cleaned up the source distribution, removing non-free
	  files from the original GPL Ghostscript release (STR
	  #1165)
	- Fixed an obscure CMYK rendering bug (STR #1152)
	- Optimized 16-bit output from the CUPS raster device.
	- Correct the inappropriate pitch bytes handling 
          for drawing bitmaps on 64bit.


CHANGES IN 8.15rc3

	- The ESP Ghostscript utility scripts (ps2ps, ps2pdf,
	  etc.) now try to run the "gs" command in the same
	  directory as the script first.  This allows multiple
	  versions of ESP Ghostscript to coexist more easily (STR
	  #1125)
	- The pswrite device made its dictionary readonly, which
	  caused problems with certain PostScript printers (STR
	  #1100)
	- ps2epsi failed when invoking sed (STR #261)
	- The CUPS device now supports 16-bit per color rendering.
	- Fix of the buffer alignment of the drivers "imagen" and
	  "lx5000" (Thanks to Werner Fink from SuSE).
	- Fix to get the TTF engine to work even on 64bit
	  architectures (Thanks to Werner Fink from SuSE).
	- Fix to allow a printer driver to switch the polarity in
	  the case  of switching from gray mode into color mode,
	  e.g. with  "-dBitsPerPixel=1" (Thanks to Werner Fink
	  from SuSE).
	- Enabled the usage of pipes within -sOutputFile even for
	  the old  japanese printers, "alc1900", and others
	  (Thanks to Werner Fink from SuSE).
	- Corrected the PPD files cbjc600.ppd, cbjc800.ppd,
	  ghostpdf.ppd to be fully Adobe-compliant so that they
	  are accepted by CUPS (Thanks to Werner Fink from SuSE).
	- Antialiasing fix for X screen display (Thanks to Werner
	  Fink from SuSE).
	- 64-bit pointer align fix (Thanks to Werner Fink from
	  SuSE).
	- Fix to copy all image information (Thanks to Werner
	  Fink from SuSE).
	- Fix the opvp problem that fails to handle index colored
	  BW images.
	- The PNG devices were missing from the configure script
	  (STR #1113)
	- The opvp driver requires both dlopen() and
	  iconv_open() support, which were not checked in the
	  configure script (STR #1107)
	- RPMs created using the ghostscript.spec file did not
	  include the correct fontpath (STR #1112)
	- The previous default mapping of stdout to stderr
	  caused problems for some programs (STR #1108)
	- Re-added section to README which tells that all
	  non-obsolete compile-in drivers and UPP files as
	  listed on linuxprinting.org are included
	- Added remaining old Japanese printer drivers:
	  "dmprt",  "escpage", "lp2000", "npdl", "rpdl" (Thanks
	  to Werner Fink from SuSE for converting them to the
	  new API, STR #1094)
	- Fixed C99-isms in several add-on drivers that
	  prevented compiles to work on non-C99 compilers (STR
	  #1104, STR #1114)
	- Fixed segfault problem of opvp driver on AMD64.
	- Fixed gamma correction bug of opvp driver.
	- Fixed illegal color conversion bug on opvp gray device.
	- Fixed opvp segfault problem caused by Ghostscript 8.15 
	  font rasterization.
	- Fixed lips4v segfault problem caused by Ghostscript 8.15
	  font rasterization.
	- Fixed Makefile.in to also compile the PNG and JBIG2 stuff
	- Added the free Epson Kowa laser printer drivers for the EPL
          (non-L) series, the AcuLaser series, and the japanese LP
          series


CHANGES IN 8.15rc2

	- The PCL XL driver now supports duplexing and media
	  sources.
	- The CUPS driver now supports choosing a media size by
	  dimensions and bottom-left margins (STR #855)
	- Fixed IJS driver bug in KRGB and 1-bit colorspace
	  support (STR #1077)
	- Added many old Japanese printer drivers: "ljet4pjl",
	  "lj4dithp", "dj505j", "picty180", "lips2p", "bjc880j",
	  "pr201", "pr150", "pr1000", "pr1000_4", "jj100",
	  "bj10v", "bj10vh", "mag16", "mag256", "mj700v2c",
	  "mj500c", "mj6000c", "mj8000c", "fmpr", "fmlbp",
	  "ml600", "lbp310", "lbp320", "md50Mono", "md50Eco",
	  "md1xMono"
	- Fixed PCL-XL driver color bug (STR #1080)
	- Merged bug fixes from GPL Ghostscript CVS (STR #1083)
	- Fixed segfault problem on PowerPC platform (STR #1079)
	- Fixed building of dynamically linked X drivers
	  ("./configure --enable-dynamic")
	- Fixed problem with compiling both of the LIPS drivers
	  at the same time (STR #1078)
	- Added missing opvp and oprp drivers to configure
	  script.


CHANGES IN 8.15rc1

	- Updated to GPL Ghostscript 8.15.
	- Added support for Omni with glib 2.0 (STR #625)
	- Changed default behavior of "print" and related
	  operators to send output to stderr instead of stdout;
	  use the "-sstdout=foo" option to send to a specific
	  file/descriptor (STR #815)
	- Integrated shared library support patch.
	- Integrated CUPS driver patch.
	- Added "addons" subdirectory for additional drivers and
	  features which are not part of GPL GhostScript.
	- Added "hl1240"/"hl1250" drivers for the Brother HL-...
	  PCL-5e  laser printers.
	- Fixed PostScript interpreter bugs reported by Martin
	  Lottermoser in the gs-mods.txt file of his "pcl3"
	  driver package.
	- Added Martin Lottermoser's "pcl3" driver for older HP
	  inkjet printers (PCL 3/3+ printer language).
	- Added Samsung's "gdi" driver for the Samsung SmartGDI
	  and some cheap Lexmark lasers.
	- Added the "lxm3200" driver for the Lexmark 3200, Z12,
	  and Z31.
	- Added KRGB support for the "ijs" device (so that HPs
	  inkjets used with HPIJS use black ink for black text
	  and graphical elements).
	- Added the "bjc250gs" driver for Canon BJC-250,
	  BJC-250ex, and BJC-1000.
	- Added third-party .upp files from ESP GS 7.07.x (now
	  all .upp files mentioned on linuxprinting.org are
	  available).
	- Let "make install" also install special features from
	  the addons/ directory (currently "pcl3opts" of the
	  "pcl3" driver and the extra .upp files in
	  addons/uniprint/).
	- Added the "lex5700"/"lex7000"/"lex2050"/"lex3200"
	  driver for various Lexmark inkjets.
	- Added the "lx5000" driver for the Lexmark 5000.
	- Added old GNU GhostScript drivers: "cdj670", "cdj850",
	  "cdj880", "cdj890", "cdj970", "cdj1600", "chp2200",
	  "dl2100", "la50", "la70", "la75", "la75plus", "ln03",
	  "oki4w", "xes" for several older HP, DEC, Okidata, and
	  Xerox printers.
	- Added the "lxm5700m" driver for the Lexmark 5700
	  (monochrome mode).
	- Added the "md2k"/"md5k" drivers for the MicroDry
	  printers from Alps and Okidata.
